#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

/******* seek_mode values for ISO11172_stream() */

#define PACK_START_CODE 0x000001BA
#define SYSTEM_HEADER_START_CODE 0x000001BB
#define PACKET_START_CODE_PREFIX 0x000001
#define ISO11172_END_CODE 0x000001B9
#define RESERVED_STREAM 0xBC
#define PICTURE_START_CODE 0x00000100
#define PRIVATE_STREAM_1 0xBD
#define PADDING_STREAM 0xBE
#define PRIVATE_STREAM_2 0xBF
#define SEQUENCE_HEADER_CODE 0x000001B3
#define EXTENSION_START_CODE 0x000001B5
#define USER_START_CODE 0x000001B2
#define GROUP_START_CODE 0x000001B8

#define CHECK_AUDIO(x) (((x) & 0xE0) == 0xC0 ? 1:0)
#define CHECK_VIDEO(x) (((((x) & 0xF0) == 0xE0) || (((x) & 0xF1) == 0xE1))\
			 ? 1:0)
#define CHECK_RESERVED(x) (((x) & 0xF0) == 0xF0 ? 1:0)
#define CHECK_PRIVATE_STREAM_2(x) (((x) & 0xFF) == 0xBF ? 1:0)

#define MAXSIZE 200
#define MAXFRAMES 20000
#define COMMENT
#define ifone(i) (i==1)?1:0


#define INTSWAP(iv, cp)	 (cp)[0] = (iv) >> 24;\
			 (cp)[1] = ((iv) >> 16) & 0xFF;\
			 (cp)[2] = ((iv) >> 8) & 0xFF;\
			 (cp)[3] = (iv) & 0xFF;

#define SHORTSWAP(iv, cp) (cp)[0] = (iv) >> 8;\
			  (cp)[1] = (iv) & 0xFF;

#define PICTTYPE(x, pict) type = ((x) & 0x38);\
                switch (type) {\
		 case 0x08 : pict = 'I'; break;\
		 case 0x10 : pict = 'P'; break;\
		 case 0x18 : pict = 'B'; break;\
		 default: printf("Other type %c \n", type); pict = 'O'; break;\
}


extern int seek_start_code ();
extern int ISO11172_stream();
extern unsigned int nextint();
extern int pack();
extern unsigned int packet(int, int);
extern void append();
extern void initvar();
extern void wrap_up();
extern void frame_ops(unsigned char, unsigned char, int);
extern void putshort(unsigned short, int, short );
extern int  write_hdrs(int, short);
extern void assign_num_parts(int);
extern void find_frame_offsets(int, int);
extern void print_frame_offsets(FILE *);
extern void fill_offsets(int, long *);
/******************************************************************/
